//
//  HTML PAGE
//
const char PAGE_WiFiSettings[] PROGMEM =  R"=====(
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<meta http-equiv="Content-type" content="text/html; charset=utf-8">
<title>Led_clock_weath на ESP-12 ver:5.21 (By IvanZah)</title>
<body onload="load();">
  <div class="container">
    <div class="row" style="text-align:center;">
      <h1 style="margin:50px;">Подключаемся к вашему Wi-Fi</h1>
      <div class="col-sm-offset-2 col-sm-8 col-md-offset-3 col-md-6">
        <h5 class="alert-info" id="ip"><strong>Сейчас Ваш IP </strong>{{ip}}</h5>
        <hr>
        <div class="alert alert-dismissible alert-warning">
          <strong>Подключнитесь к  вашей WiFi сети.</strong> Это позволит управлять часамим в локальной сети и синхронизировать время используя ваш роутер.
        </div>
        <hr>
        <div class="row">
          <div class="col-sm-6" style="margin-top: 12px;">
            <div class="alert alert-dismissible alert-warning"> 
              Название и пароль вашей сети
            </div>
          </div>
          <div class="col-sm-6">
            <input id="ssid" value="{{ssid}}" class="form-control" pattern="[-\w\s#@./]{1,20}" placeholder="Название вашего WiFi">
            <input id="password" value="{{password}}" pattern=".{0,20}" onfocus="this.type='text'" type="password" class="form-control" placeholder="Пароль">
            <input class="btn btn-block btn-success" value="Сохранить" onclick="set_ssid(this);" type="submit">
          </div>
        </div>
        <hr>
        <div class="row" >
          <div class="col-sm-6" style="margin-top: 12px;">
            <div class="alert alert-dismissible alert-warning"style="padding-top:8px; padding-bottom: 9px;">
              Название AP часов (IP_192.168.4.1)
            </div>
          </div>
          <div class="col-sm-6">
            <input id="ssidap" value="{{ssidAP}}" class="form-control" pattern="[-\w\s#@./]{1,20}" placeholder="Има AP ESP">
            <input id="passwordAp" value="{{passwordAP}}" pattern=".{0,20}" onfocus="this.type='text'" type="password" class="form-control" placeholder="Пароль">
            <input class="btn btn-block btn-success" value="Сохранить" onclick="set_ssid_ap(this);" type="submit">
          </div>
        </div>
        <hr>
        <a class="btn btn-block btn-default" href="/">Настройки подключения к Wi-Fi</a>
        <a class="btn btn-block btn-default" href="/time.htm">Настройка времени</a>
        <a class="btn btn-block btn-default" href="/weather.htm">Настройка погоды</a>
        <a class="btn btn-block btn-default" href="/mqtt.htm">Настройка  MQTT сервера</a>
        <a class="btn btn-block btn-default" href="/led.htm">Настройка экрана</a>
        <a class="btn btn-block btn-default" href="/update.htm">Обновление прошивки</a>
        <a class="btn btn-block btn-default" href="/help.htm">Помощь</a>
        <input class="btn btn-block btn-danger" value="Перезагрузить устройство" onclick="restart(this,'Вы действительно хотите перезагрузить устройство?');" type="submit">
      </div>
    </div>
  </div>
</body>

<head>
  <link rel="stylesheet" href="/bootstrap.min.css">
  <link rel="stylesheet" type="text/css" href="/style.css">
  <script type="text/javascript" src="/function.js"></script>
  <script type="text/javascript">
  
  function set_ssid(submit){
      server = "/ssid?ssid="+val('ssid')+"&password="+encodeURIComponent(val('password'));
      send_request(submit,server);
      alert("Изменения вступят в силу после перезагрузки. Пожалуйста перезагрузите устройство.");
    }
    function set_ssid_ap(submit){
      server = "/ssidap?ssidAP="+val('ssidap')+"&passwordAP="+encodeURIComponent(val('passwordAp'));
      send_request(submit,server);
      alert("Изменения вступят в силу после перезагрузки. Пожалуйста перезагрузите устройство.");
    }
    function restart(submit,texts){
      if (confirm(texts)) {
      server = "/restart?device=ok";
        send_request(submit,server);
        return true;
      } else {
          return false;
      }
    }
  </script>
</head>
)=====";
